<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css" integrity="sha384-B0vP5xmATw1+K9KRQjQERJvTumQW0nPEzvF6L/Z6nronJ3oUOFUFpCjEUQouq2+l" crossorigin="anonymous"/>

    <title>Bootstrap Flex</title>
</head>
<body>
    
    <div class="text-center">
        <h1>Bootstrap Flex</h1>
        <p>Use d-flex class to create a flex container and transform direct children into flex items</p>

        <!-- d-flex -->
		<!-- we use d-flex to easily aligns our elements vertically or horizontally -->
        
        <h2>Centering Elements</h2>

        <h3>Centering flex-column without align-items-center</h3>
        <div style="height: 500px" class="bg-secondary p-3 justify-content-center d-flex flex-column">
            <div class="h-25 p-3 bg-success">
                Flex Item A
            </div>

            <div class="h-25 p-3 bg-warning">
                Flex Item B
            </div>

            <div class="h-25 p-3 bg-danger">
                Flex Item C
            </div>
        </div>

        <div style="height: 500px" class="bg-secondary p-3 align-items-center justify-content-center d-flex flex-column">
            <div class="h-25 p-3 bg-success">
                Flex Item A
            </div>

            <div class="h-25 p-3 bg-warning">
                Flex Item B
            </div>

            <div class="h-25 p-3 bg-danger">
                Flex Item C
            </div>
        </div>

        <h2>Flex Row</h2>

        <div class="bg-dark p-3 d-flex flex-row">
            <div class="p-3 bg-success">
                Flex Item A
            </div>

            <div class="p-3 bg-warning">
                Flex Item B
            </div>

            <div class="p-3 bg-danger">
                Flex Item C
            </div>
        </div>

        <h2>Flex Row Center</h2>
        
        <div class="bg-dark p-3 d-flex flex-row justify-content-center">
            <div class="p-3 bg-success">
                Flex Item A
            </div>

            <div class="p-3 bg-warning">
                Flex Item B
            </div>

            <div class="p-3 bg-danger">
                Flex Item C
            </div>
        </div>

        <h2>Flex Row Reverse</h2>

        <div class="bg-dark p-3 d-flex flex-row flex-row-reverse">
            <div class="p-3 bg-success">
                Flex Item A
            </div>

            <div class="p-3 bg-warning">
                Flex Item B
            </div>

            <div class="p-3 bg-danger">
                Flex Item C
            </div>
        </div>

        <h2>Creating Space Between Elements</h2>

        <div class="bg-dark p-3 d-flex justify-content-around">
            <div class="p-3 bg-success col-md-2">
                Flex Item A
            </div>
            <div class="p-3 bg-warning col-md-2">
                Flex Item B
            </div>
            <div class="p-3 bg-danger col-md-2">
                Flex Item C
            </div>
        </div>

        <!-- d-flex default behaviour is flex-row -->

        <h2>Flexbox with Margin</h2>

        <div class="bg-dark p-3 d-flex ">
            <div class="p-3 bg-success ml-auto mr-auto">Flex Item A</div>
            <div class="p-3 bg-warning">Flex Item B</div>
            <div class="p-3 bg-danger">Flex Item C</div>
            <div class="p-3 bg-primary">Flex Item D</div>
        </div>

        <h2>Nested Flex Elements</h2>
        <!-- sm = small devices above -->
        <!-- md = medium devices above -->
        <!-- lg = large devices above -->

        <!-- NOTE: follow Mobile-first principle -->
        <div class="bg-dark p-3 d-sm-block d-md-flex" >
            <div class="p-3 bg-success mr-auto">Flex Item A</div>
            <div class="w-50 d-sm-block d-md-flex flex-column justify-content-between">
                <div class="p-3 bg-warning">Flex Item B.1</div>
                <div class="p-3 bg-danger">Flex Item B.2</div>
                <div class="p-3 bg-primary">Flex Item B.3</div>
            </div>
        </div>

    </div>

    <h1>Mini Activity</h1>
        <!-- Mini Activity 1 -->
	<div class="mt-5 mb-5 d-flex flex-sm-column flex-md-row justify-content-around ml-3 mr-3">

		<!-- The elements should be aligned horizontally if the device size is medium or large -->
		<!-- While in small devices it should be aligned vertically -->
		<div class="col-md-4 text-center">
			<img class="img-fluid" src="images/blue.png">
			<div>I'm a blue photo</div>
		</div> 

		<div class="col-md-4 text-center">
			<img class="img-fluid" src="images/red.png">
			<div>I'm a red photo</div>
		</div> 

		<div class="col-md-4 text-center">
			<img class="img-fluid" src="images/green.png">
			<div>I'm a green photo</div>
		</div> 

	</div>

	<!-- Mini Activity 2 -->
	<!-- 1.A Align all blue horizontally if medium to large devices -->
	<!-- 1.B Align all green horizontally if medium to large devices -->
	<!-- 1.A Align all blue vertically if medium to large devices -->
	<!-- 1.B Align all green vertically if medium to large devices -->

	<div class="mb-4">

      <div class="container-fluid align-items-center justify-content-center d-flex flex-sm-row flex-md-column">
          <div class="align-items-center justify-content-center d-flex flex-sm-column flex-md-row">
              <img width="150" class="mr-3 mb-3 " src="images/blue.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/blue.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/blue.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/blue.png"/>
          </div>
          <div class="align-items-center justify-content-center d-flex flex-sm-column flex-md-row">
              <img width="150" class="mr-3 mb-3 " src="images/green.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/green.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/green.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/green.png"/>
          </div>
      </div>

    <!-- Bootstrap Script -->
    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>